package dev.shadowsoffire.apotheosis.adventure.compat;

import dev.shadowsoffire.apotheosis.ench.Ench;
import net.minecraft.world.item.enchantment.Enchantment;
import java.util.function.Function;
import top.theillusivec4.curios.api.SlotResult;
import top.theillusivec4.curios.api.CuriosApi;
import java.util.List;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.item.ItemStack;
import java.util.function.Predicate;

public class AdventureCuriosCompat
{
    private static final Predicate<ItemStack> HAS_LIFE_MEND;
    
    public static List<ItemStack> getLifeMendingCurios(final LivingEntity entity) {
        final List<SlotResult> slots = CuriosApi.getCuriosHelper().findCurios(entity, (Predicate)AdventureCuriosCompat.HAS_LIFE_MEND);
        return slots.stream().map((Function<? super Object, ? extends ItemStack>)SlotResult::stack).toList();
    }
    
    static {
        HAS_LIFE_MEND = (stack -> stack.getEnchantmentLevel((Enchantment)Ench.Enchantments.LIFE_MENDING.get()) > 0);
    }
}
